//==============================================================================
//
// IoDll.c
//
// α׷ ZapIo WDM Device Driver 񽺸 ִ ̺귯.
//
//  -  : 2003 1 4
//  -  : 
//  - ̸ : AlphaMCU@hanmail.net
//  - ּ : http://www.zap.pe.kr
//
//  - Copyright (C) 2002~2003 Kyung-Ryul Sun.
//
//==============================================================================

#define _DLL_PROJECT

#include "windows.h"
#include "IoDll.h"

#include <initguid.h> // #define INITGUID
#include <winioctl.h>
#include <setupapi.h>

#include "..\sys\DeviceInterface.h" // GUID

//
//  
//
HANDLE		m_hDevice = NULL;
TCHAR		m_SymLinkName[sizeof(TCHAR)*100];

//
// Լ Ÿ 
//
HANDLE GetDeviceHandle(GUID *pGuid, DWORD dwInstance);

//==============================================================================
//
// ⼭ ʹ API Լ ϵ..
//
//==============================================================================
ZAPIOAPI void* zio_LoadZapIo(void)
{
	// ̹ ZapIo ̹ ǰ ִ ȮѴ.
	if(m_hDevice != NULL) { return (void*)m_SymLinkName; }

	// ZapIo ̹ Ѵ.
	m_hDevice = GetDeviceHandle( (GUID *)&ZAPIO_GUID, 0 );
	if(m_hDevice == NULL) { return NULL; }

	return (void*)m_SymLinkName;
}

ZAPIOAPI BOOL zio_UnloadZapIo(void)
{
	if(m_hDevice != NULL) {
		CloseHandle(m_hDevice);
	}

	return TRUE;
}

//==============================================================================
//
// ⼭ ʹ  ϴ Լ ϵ..
//
//==============================================================================
HANDLE GetDeviceHandle(GUID *pGuid, DWORD dwInstance)
{
	HANDLE hDevice = NULL;

	HDEVINFO devInfo = NULL;
	PSP_INTERFACE_DEVICE_DETAIL_DATA pDetailData = NULL;

	__try {
		BOOL bSuccess;

		// SetupDiGetClassDevs
		//
		//  The returned device information set contains devices that expose
		//  interfaces of the requested interface class. Enumerate the interfaces
		//  of the devices using SetupDiEnumDeviceInterfaces.
		//
		//  The caller of this function must delete the returned device
		//  information set when it is no longer needed by calling
		//  SetupDiDestroyDeviceInfoList.
		//
		devInfo = SetupDiGetClassDevs(
			pGuid,
			NULL,
			NULL,
			DIGCF_PRESENT | DIGCF_DEVICEINTERFACE
		);
		if( devInfo == INVALID_HANDLE_VALUE ) { return (HANDLE)NULL; }

		// SetupDiEnumDeviceInterfaces
		//
		//  SetupDiEnumDeviceInterfaces returns a context structure for
		//  a device interface element of a device information set
		//
		SP_DEVICE_INTERFACE_DATA ifData;
		ifData.cbSize = sizeof(SP_DEVICE_INTERFACE_DATA);
		bSuccess = SetupDiEnumDeviceInterfaces(
			devInfo,
			NULL,
			pGuid,
			dwInstance,
			&ifData
		);
		if( !bSuccess ) { return (HANDLE)NULL; }

		// SetupDiGetDeviceInterfaceDetail
		//
		//  Get size of Symbolic Link Name.
		//
		//  This function fails with GetLastError returning ERROR_INSUFFICIENT_BUFFER. 
		//
		DWORD dwBufferSize;
		bSuccess = SetupDiGetDeviceInterfaceDetail(
			devInfo,
			&ifData,
			NULL,
			0,
			&dwBufferSize,
			NULL
		);
		if( bSuccess || GetLastError() != ERROR_INSUFFICIENT_BUFFER ) {
			return (HANDLE)NULL;
		}

		// Allocate buffer
		//
		pDetailData = (PSP_INTERFACE_DEVICE_DETAIL_DATA)(new char[dwBufferSize]);
		if( !pDetailData) { return (HANDLE)NULL; }

		// SetupDiGetDeviceInterfaceDetail
		//
		//  Get Symbolic Link Name.
		//
		pDetailData->cbSize = sizeof(SP_INTERFACE_DEVICE_DETAIL_DATA);
		bSuccess = SetupDiGetDeviceInterfaceDetail(
			devInfo,
			&ifData,
			pDetailData,
			dwBufferSize,
			NULL,
			NULL
		);
		if( !bSuccess ) { return (HANDLE)NULL; }

		// CreateFile
		//
		//  Get device handle
		//
		hDevice = CreateFile(
			pDetailData->DevicePath,
			GENERIC_READ | GENERIC_WRITE,
			FILE_SHARE_READ | FILE_SHARE_WRITE,
			NULL,
			OPEN_EXISTING,
			FILE_ATTRIBUTE_NORMAL,
			NULL
		);
		if( hDevice == INVALID_HANDLE_VALUE ) { 
			return (HANDLE)NULL;
		} else {
			// Symbolic Link Name 
			lstrcpy(m_SymLinkName, pDetailData->DevicePath);
		}

	} // __try
	__finally {

		// SetupDiDestroyDeviceInfoList
		if( devInfo != NULL && devInfo != INVALID_HANDLE_VALUE ) {
			SetupDiDestroyDeviceInfoList(devInfo);
		}

		// free pDetailData buffer
		if( pDetailData ) {
			delete []((char*)(pDetailData));
		}

	} // __finally

	return (HANDLE)hDevice;
}
